import 'package:tencent_im_sdk_plugin/models/v2_tim_value_callback.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_callback.dart';
import 'package:tiw_im_plugin_example/im_manager.dart';

import 'GenerateTestUserSig.dart';

const String SDK_KEY = 'c1b0aa6f4c39d3ba673da46d82a6d8e22c58d25b75bf717a68c753f7ea9e914f';
const int SDK_APPID = 1400527064;

class LoginManager {
  //获取腾讯即时通信IM manager;
  IMManager imManager = IMManager.getInstance();
  String _currentUid;
  String _currentUsig;
  String _currentRoomId;

  Future<bool> initTIMManager() async {
    ///初始化SDK
    V2TimValueCallback<bool> initRes = await imManager.initSdk(initListener);

    if (initRes.code == 0) {
      return true;
    }
    return false;
  }

  //登陆
  Future<V2TimCallback> login(String userId) async{
    String userSig = GenerateTestUserSig(sdkappid: SDK_APPID, key: SDK_KEY)
        .genSig(identifier: userId, expire: 24 * 60 * 60 * 1000);
    V2TimCallback loginRes = await imManager.login(userId, userSig);
    if (loginRes.code == 0) {
      _currentUid = userId;
      _currentUsig = userSig;
    }
    return loginRes;
  }

  //创建房间
  Future<V2TimValueCallback<String>> createGroup(String groupId) async {
    V2TimValueCallback<String> joinRes = await imManager.getInnerIM().createGroup(
        groupType: "AVChatRoom", groupName: "groupName_" + groupId, groupID: groupId);
    return joinRes;
  }

  //进房
  Future<V2TimCallback> joinGroup(String groupId) async {
    V2TimCallback joinRes = await imManager.getInnerIM().joinGroup(groupID: groupId, message: _currentUid + "_" + groupId);
    if (joinRes.code == 0) {
      _currentRoomId = groupId;
    }
    return joinRes;
  }

  //退房
  Future<V2TimCallback> quitGroup(String groupId) async {
    V2TimCallback res = await imManager.getInnerIM().quitGroup(groupID: groupId);
    if(res.code == 0){
      _currentRoomId = '';
    }
    return res;
  }

  String getCurrentUid(){
    return _currentUid;
  }

  String getCurrentSig(){
    return _currentUsig;
  }

  void initListener(data) {
    String type = data.type;
    print(type);
  }
}
